Loading...
Searching...
No Matches
BALL::ResidueRotamerSet Class Reference
Molecular Modeling » Molecular Structure » Rotamers

`#include <BALL/STRUCTURE/residueRotamerSet.h>`

## Classes

struct | RotamerProbabilityGreaterThan_

## Public Types

Type definitions
typedef std::vector< Rotamer >::const_iterator | ConstIterator
typedef std::vector< Rotamer >::const_iterator | const_iterator
typedef std::vector< Rotamer >::iterator | Iterator
typedef std::vector< Rotamer >::iterator | iterator

## Public Member Functions

Constructors and Destructors
| ResidueRotamerSet ()
| ResidueRotamerSet (const ResidueRotamerSet &rotamer_set)
| ResidueRotamerSet (const Residue &residue, Size number_of_torsions)
virtual | ~ResidueRotamerSet ()
External Iteration
Iterator | begin ()
Iterator | end ()
ConstIterator | begin () const
ConstIterator | end () const
Assignment
const ResidueRotamerSet & | operator= (const ResidueRotamerSet &residue_rotamer_set)
| The assignment operator.
Accessors
const String & | getName () const
| Get the name of the ResidueRotamerSet.
bool | isValid () const
| Find out if the class instance is valid.
Size | getNumberOfRotamers () const
| Return the number of rotamers from this residue rotamer set.
Size | getNumberOfTorsions () const
void | setNumberOfTorsions (Size number_of_torsions)
const Rotamer & | operator[] (Position index) const
bool | hasTorsionPhi () const
Angle | getTorsionPhi () const
void | setTorsionPhi (const Angle &phi)
bool | hasTorsionPsi () const
Angle | getTorsionPsi () const
void | setTorsionPsi (const Angle &psi)

## Rotamer Assignment

bool | valid_
| Indicates whether the instance is valid.
String | name_
| Name of the residue (variant name).
std::vector< Rotamer > | rotamers_
| Array containing all rotamers.
std::vector< String > | movable_atoms_chi1_
| Names of the movable atoms (names) for each of the torsions.
std::vector< String > | movable_atoms_chi2_
std::vector< String > | movable_atoms_chi3_
std::vector< String > | movable_atoms_chi4_
Size | number_of_torsions_
| Number of valid torsions in the side chain.
StringHashMap< Vector3 > | original_coordinates_
| Original coordinates of the template residue.
bool | has_torsion_phi_
| true if this residue rotamer set is backbone dependent
bool | has_torsion_psi_
| true if this residue rotamer set is backbone dependent
Angle | phi_
| The torsion phi.
Angle | psi_
| The torsion psi.
bool | setTemplateResidue (const Residue &residue, Size number_of_torsions)
| Set the template residue, name, base coordinates ...
bool | setRotamer (Residue &residue, const Rotamer &rotamer)
Rotamer | getRotamer (const Residue &residue) const
const Rotamer & | getRotamer (Position index) const
void | setName (const String &name)
| Assign a new name.
void | addRotamer (const Rotamer &rotamer)
| Add a rotamer to the current set.
void | deleteRotamer (Iterator loc)
| Delete the Rotamer at the given iterator location.
void | deleteRotamers (Iterator begin, Iterator end)
| Delete the range of rotamers.
void | sort ()
| Sort the rotamers descendingly according to their probability.
void | addMovable_ (std::vector< String > &movable, const Atom &a, const HashSet< String > &assigned_atoms)
void | setTorsionAngle_ (Residue &residue, const std::vector< String > &movable, float torsion)
| Set the torsion angles.

## Detailed Description

Residue Rotamer Set.

This class stores all potential rotamers for a given side chain type. By linking a residue rotamer set to a specific side chain, one can iteratively try all contained rotamers for this side chain. The rotamers for a side chain are typically stored in a rotamer library .

The basic functionality is to store the rotamers and to modify residues according to this rotamers.

Definition at line 87 of file residueRotamerSet.h.

## Member Typedef Documentation

## const_iterator

typedef std::vector<Rotamer>::const_iterator BALL::ResidueRotamerSet::const_iterator

Definition at line 96 of file residueRotamerSet.h.

## ConstIterator

typedef std::vector<Rotamer>::const_iterator BALL::ResidueRotamerSet::ConstIterator

Definition at line 95 of file residueRotamerSet.h.

## Iterator

typedef std::vector<Rotamer>::iterator BALL::ResidueRotamerSet::Iterator

Definition at line 98 of file residueRotamerSet.h.

## iterator

typedef std::vector<Rotamer>::iterator BALL::ResidueRotamerSet::iterator

Definition at line 99 of file residueRotamerSet.h.

## Constructor & Destructor Documentation

## ResidueRotamerSet() [1/3]

BALL::ResidueRotamerSet::ResidueRotamerSet | ( |  | ) |

Default constructor.

## ResidueRotamerSet() [2/3]

BALL::ResidueRotamerSet::ResidueRotamerSet | ( | const ResidueRotamerSet & | rotamer_set | ) |

Copy constructor

## ResidueRotamerSet() [3/3]

BALL::ResidueRotamerSet::ResidueRotamerSet | ( | const Residue & | residue,
|  | Size | number_of_torsions )

Detailed constructor

## ~ResidueRotamerSet()

virtual BALL::ResidueRotamerSet::~ResidueRotamerSet | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## addMovable_()

void BALL::ResidueRotamerSet::addMovable_ | ( | std::vector< String > & | movable,
|  | const Atom & | a,
|  | const HashSet< String > & | assigned_atoms )

protected

Determine all movable atoms. This method walks along the bonds starting at a and adds them to the movable vector. Atoms whose names are contained in assigned_atoms are ignored.

## addRotamer()

void BALL::ResidueRotamerSet::addRotamer | ( | const Rotamer & | rotamer | ) |

Add a rotamer to the current set.

## begin() [1/2]

Iterator BALL::ResidueRotamerSet::begin | ( |  | ) |

inline

Definition at line 132 of file residueRotamerSet.h.

## begin() [2/2]

ConstIterator BALL::ResidueRotamerSet::begin | ( |  | ) | const

inline

Definition at line 146 of file residueRotamerSet.h.

## deleteRotamer()

void BALL::ResidueRotamerSet::deleteRotamer | ( | Iterator | loc | ) |

Delete the Rotamer at the given iterator location.

## deleteRotamers()

void BALL::ResidueRotamerSet::deleteRotamers | ( | Iterator | begin,
|  | Iterator | end )

Delete the range of rotamers.

## end() [1/2]

Iterator BALL::ResidueRotamerSet::end | ( |  | ) |

inline

Definition at line 139 of file residueRotamerSet.h.

## end() [2/2]

ConstIterator BALL::ResidueRotamerSet::end | ( |  | ) | const

inline

Definition at line 153 of file residueRotamerSet.h.

## getName()

const String & BALL::ResidueRotamerSet::getName | ( |  | ) | const

Get the name of the ResidueRotamerSet.

## getNumberOfRotamers()

Size BALL::ResidueRotamerSet::getNumberOfRotamers | ( |  | ) | const

Return the number of rotamers from this residue rotamer set.

## getNumberOfTorsions()

Size BALL::ResidueRotamerSet::getNumberOfTorsions | ( |  | ) | const

Return the number of valid torsions in the side chain. The number returned is between zero and four.

## getRotamer() [1/2]

Rotamer BALL::ResidueRotamerSet::getRotamer | ( | const Residue & | residue | ) | const

Calculate the torsion angle of a residue. Retrieve the side-chain torsion angles from the residue's current conformation.

## getRotamer() [2/2]

const Rotamer & BALL::ResidueRotamerSet::getRotamer | ( | Position | index | ) | const

Return a reference to a given rotamer by number. The index should be in the range [0, getNumberOfRotamers ()[, however the index is computed modulo the maximum number, so it really doesn't matter.

## getTorsionPhi()

Angle BALL::ResidueRotamerSet::getTorsionPhi | ( |  | ) | const

## getTorsionPsi()

Angle BALL::ResidueRotamerSet::getTorsionPsi | ( |  | ) | const

## hasTorsionPhi()

bool BALL::ResidueRotamerSet::hasTorsionPhi | ( |  | ) | const

## hasTorsionPsi()

bool BALL::ResidueRotamerSet::hasTorsionPsi | ( |  | ) | const

## isValid()

bool BALL::ResidueRotamerSet::isValid | ( |  | ) | const

Find out if the class instance is valid.

## operator=()

const ResidueRotamerSet & BALL::ResidueRotamerSet::operator= | ( | const ResidueRotamerSet & | residue_rotamer_set | ) |

The assignment operator.

## operator[]()

const Rotamer & BALL::ResidueRotamerSet::operator[] | ( | Position | index | ) | const

Random access operator for single rotamers.

Exceptions

  BALL::Exception::IndexOverflow |

## setName()

void BALL::ResidueRotamerSet::setName | ( | const String & | name | ) |

Assign a new name.

## setNumberOfTorsions()

void BALL::ResidueRotamerSet::setNumberOfTorsions | ( | Size | number_of_torsions | ) |

Set the number of valid torsions for this side chain.

Exceptions

  BALL::Exception::IndexOverflow | if the number of torsions is above four.

## setRotamer()

bool BALL::ResidueRotamerSet::setRotamer | ( | Residue & | residue,
|  | const Rotamer & | rotamer )

Assign a specific rotamer. Set the side-chain torsions of residue to the values specified by rotamer.

## setTemplateResidue()

bool BALL::ResidueRotamerSet::setTemplateResidue | ( | const Residue & | residue,
|  | Size | number_of_torsions )

Set the template residue, name, base coordinates ...

## setTorsionAngle_()

void BALL::ResidueRotamerSet::setTorsionAngle_ | ( | Residue & | residue,
|  | const std::vector< String > & | movable,
|  | float | torsion )

protected

Set the torsion angles.

## setTorsionPhi()

void BALL::ResidueRotamerSet::setTorsionPhi | ( | const Angle & | phi | ) |

## setTorsionPsi()

void BALL::ResidueRotamerSet::setTorsionPsi | ( | const Angle & | psi | ) |

## sort()

void BALL::ResidueRotamerSet::sort | ( |  | ) |

Sort the rotamers descendingly according to their probability.

## Member Data Documentation

## has_torsion_phi_

bool BALL::ResidueRotamerSet::has_torsion_phi_

protected

true if this residue rotamer set is backbone dependent

Definition at line 298 of file residueRotamerSet.h.

## has_torsion_psi_

bool BALL::ResidueRotamerSet::has_torsion_psi_

protected

true if this residue rotamer set is backbone dependent

Definition at line 301 of file residueRotamerSet.h.

## movable_atoms_chi1_

std::vector<String> BALL::ResidueRotamerSet::movable_atoms_chi1_

protected

Names of the movable atoms (names) for each of the torsions.

Definition at line 286 of file residueRotamerSet.h.

## movable_atoms_chi2_

std::vector<String> BALL::ResidueRotamerSet::movable_atoms_chi2_

protected

Definition at line 287 of file residueRotamerSet.h.

## movable_atoms_chi3_

std::vector<String> BALL::ResidueRotamerSet::movable_atoms_chi3_

protected

Definition at line 288 of file residueRotamerSet.h.

## movable_atoms_chi4_

std::vector<String> BALL::ResidueRotamerSet::movable_atoms_chi4_

protected

Definition at line 289 of file residueRotamerSet.h.

## name_

String BALL::ResidueRotamerSet::name_

protected

Name of the residue (variant name).

Definition at line 280 of file residueRotamerSet.h.

## number_of_torsions_

Size BALL::ResidueRotamerSet::number_of_torsions_

protected

Number of valid torsions in the side chain.

Definition at line 292 of file residueRotamerSet.h.

## original_coordinates_

StringHashMap<Vector3> BALL::ResidueRotamerSet::original_coordinates_

protected

Original coordinates of the template residue.

Definition at line 295 of file residueRotamerSet.h.

## phi_

Angle BALL::ResidueRotamerSet::phi_

protected

The torsion phi.

Definition at line 304 of file residueRotamerSet.h.

## psi_

Angle BALL::ResidueRotamerSet::psi_

protected

The torsion psi.

Definition at line 307 of file residueRotamerSet.h.

## rotamers_

std::vector<Rotamer> BALL::ResidueRotamerSet::rotamers_

protected

Array containing all rotamers.

Definition at line 283 of file residueRotamerSet.h.

## valid_

bool BALL::ResidueRotamerSet::valid_

protected

Indicates whether the instance is valid.

Definition at line 277 of file residueRotamerSet.h.